<?php
/**
*
* Router class
* 
*/
class Router{

	public static $URL_PART;
	public static $_DATA;

	private $routers = array();
	private static $is_final = false;

	private static $db;
	private static $actions = array();

	public function __construct($db){
		self::$db = $db;

	}
	public function map($router, $callback = null){
		if(!isset($this->routers[$router])){
			$this->routers[$router] = $callback;
		}
	}

	public function find_url($url){
		$parts = explode('/', $url);
		$route = "";
		$count_parts  = 0;
		
		// Get count $_GET in url
		foreach ($parts as $key => $value) {
			if(!empty($value)){
				$count_parts++;
			}
		}

		// If is map from URL
		foreach ($parts as $key => $value) {

			for ($i=0; $i < $count_parts - $key ; $i++) { 
				if(!empty($parts[$i])){
					if(substr($route, 0, -1) != '/'){
						$route .= ltrim($parts[$i], '/')."/";
					}					
				}
			}

			if(substr($route, 0, -1) != '/'){
				$route = substr($route, 0, -1);
			}
			if(isset($this->routers[$route])){
				if(is_callable($this->routers[$route])){		
					call_user_func($this->routers[$route], $parts, $url);
				}
				self::$is_final = true;
				return $url;
			}
			
			$route = "";
		}

		// If is page in DB
		$data = self::$db->select()->from('pages')->where(array('url'=>$parts[0]))->fetchSingle();
		if(self::$db->getRows() > 0 && $count_parts <= 1){
			self::$_DATA = $data;
			self::$is_final = true;
			return $parts[0];
		}else{
			// Multiple link url
			$url_404 = "";
			foreach ($parts as $key => $value) {

				for ($i=0; $i < $count_parts - $key ; $i++) { 
					if(!empty($parts[$i])){
						if(substr($url_404, 0, -1) != '/'){
							$url_404 .= ltrim($parts[$i],'/').'/';
						}					
					}

				}
				if(substr($url_404, 0, -1) != '/'){
					$url_404 = substr($url_404, 0, -1);
				}
				$data = self::$db->select()->from('pages')->where(array('url'=>$url_404))->fetchSingle();

				if(self::$db->getRows() > 0){
					self::$_DATA = $data;
					self::$is_final = true;

					return $url_404;
				}


				$url_404 = "";
			}
		}

		self::$is_final = true;
		return 404;
		
	}
	public function load_home()
	{
		if(isset($this->routers['/'])){
			if(is_callable($this->routers['/'])){		
				call_user_func($this->routers['/'], '', '/');
			}
			self::$is_final = true;
			return '/';
		}
	}
	
	static function is_final(){
		return self::$is_final;
	}

}

?>